function m = LHM( h, mu )

% -------------------------------------------------------------------------
% An implementation of "Log-based Histogram Modification."
%
% -------------------------------------------------------------------------
% Input variables
%   h   : input histogram vector whose length is 255.
%   mu  : determines the level of the modification. Typically it ranges
%   between 5.0 and 5.5.
%
% Output variables
%   m : output modified histogram.
% -------------------------------------------------------------------------
%                           written by Chulwoo Lee, chulwoo@mcl.korea.ac.kr


temp = max(h) * 10^(-mu);
denominator = max(h)*temp + 1;
numerator = h*temp + 1;

m = log(numerator) / log(denominator);
m = m/sum(m);		% m is normalized such that the sum of which is to be 1


end

