
clc; clear all;

in_file = 'kodim03.png';
out_file = 'kodim03_out.png';


%% read input file
in_RGB = imread(in_file);
[R,C,X] = size(in_RGB);

[in_Y, in_U, in_V] = rgb2yuv(in_RGB(:,:,1), in_RGB(:,:,2), in_RGB(:,:,3));
in_Y = double(in_Y);


%% extract an input histogram vector h
h = zeros(256,1);
for j=1:R
    for i=1:C
        temp = in_Y(j,i) + 1;
        h(temp,1) = h(temp,1) + 1;
    end
end
clear temp


%% modified histogram by logarithmic function
m = LHM(h, 5.0);


%% Convex optimization
D = inv(tril(ones(256,256)));
[y, ~, ~] = PCCE(m, h, 1); x = D\y;


%% write an output image
out_Y = zeros(R,C);
for j=1:R
    for i=1:C
        out_Y(j,i) = round(x(in_Y(j,i)+1));
    end
end

out_RGB = yuv2rgb(uint8(out_Y), in_U, in_V);
imwrite(out_RGB, out_file, 'png');


